stages:
  - build
  - deploy

buildGame:
  image: node:16.2.0
  stage: build
  script:
    - PATH="./node_modules/.bin:$PATH"
    - npm install
    - mtlg build production
    - cd build
    - tar -czf game.tar.gz *
    - mv ./game.tar.gz ..
  artifacts:
    paths:
      - game.tar.gz

deployGame:
  image: alpine:latest
  stage: deploy
  script:
    - apk add --no-cache curl
    - curl -#v --data-binary @game.tar.gz ${DEPLOY_URL}/${CI_PROJECT_NAME}?token=${DEPLOY_TOKEN} | cat
  variables:
    GIT_STRATEGY: none
  only:
    - master

commitGame:
  stage: deploy
  before_script:
    - 'which ssh-agent || ( apt-get update -y && apt-get install openssh-client git -y )'
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_PUBLIC_KEY" >> ~/.ssh/id_rsa.pub
    - ssh-keyscan $GIT_URL >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
    - git config --global user.email "$GITLAB_USER_EMAIL"
    - git config --global user.name "Gitlab Runner"
  script:
    - git clone $TARGET_REPO_URL target_repo
    - rm -rf target_repo/$TARGET_REPO_PATH
    - mkdir -p target_repo/$TARGET_REPO_PATH
    - mkdir build
    - tar -xzf game.tar.gz -C build
    - cp -r build/* target_repo/$TARGET_REPO_PATH
    - cd target_repo
    - git add .
    - git commit -m "Push new Game Version $GAME" || echo "Nothing new to commit."
    - git push origin master
    - cd ..
    - git clone $BACKEND_REPO_URL backend_repo
    - rm -rf backend_repo/$BACKEND_REPO_PATH
    - mkdir -p backend_repo/$BACKEND_REPO_PATH
    - mv build/* backend_repo/$BACKEND_REPO_PATH
    - cd backend_repo
    - git add .
    - git commit -m "Push new Game Version $GAME" || echo "Nothing new to commit."
    - git push origin master
  only:
    - master
